Subject: RE: [Sip] Myth Busters: Episode 1, Is STUN request processing faster than a SIP PING requestprocessing?

From: "Bharrat, Shaun" <[email-masked]>
Date: Mon, 6 Mar 2006 10:34:56 -0500

Hisham:

Glad to see actual code and test results. It is a _welcome_
sight to have full information and numbers based on real
code.

Now that I understand what is actually being done, I guess
my question is why you would have expected the numbers to
be any different? Please correct me if I am misunderstanding 
anything in what you have done. This is not doing ANY sip 
processing - it just finds the first \r\n and then copies 
everything beyond that (with a 200 + contact header prepended) 
into the response. There is no VIA processing (guess we don't need
to add received= or rport?), no Content-Length processing 
(how does it work for TCP?), etc.

If we are "allowed" to skip the SIP processing (i.e. it's
not really a SIP packet), then I agree that we can make the
processing time of a PING arbitrarily close to a STUN packet
processing. However, if we are not, I don't agree that this
is a valid comparison of a SIP-based keepalive versus a 
STUN based keepalive.

My 2c

Thanks and cheers,
Shaun

www.sonusnet.com

> -----Original Message-----
> From: Hisham Khartabil [mailto:[email-masked]]
> Sent: Monday, March 06, 2006 10:02 AM
> To: [email-masked] List
> Cc: Alan Duric; Dusan Stevanovic
> Subject: [Sip] Myth Busters: Episode 1,Is STUN request 
> processing faster
> than a SIP PING requestprocessing?
> 
> 
> I promised to come back with hard real numbers on how long it 
> will take 
> for a server to process and STUN request vs a SIP PING request
> 
> Myth: processing a STUN request is 10 to 100 times faster than a SIP 
> PING request
> 
> Assumptions:  - SIP PING request is processed early in the stack and 
> bypasses any unnecessary validations.
>                - SIP PING response carries in the contact 
> header the IP 
> address and port as appears in the IP packet (source IP and port).
> 
> We implemented the PING request as described above in the reSIProcate 
> stack. Attached you will find the c++ file where the changes 
> were made.
> STUN was already implemented in the reSIProcate stack and used as is.
> 
> Below you will see the findings:
> 
> STUN request processing: 0.15 - 0.2 ms
> SIP PING request processing: 0.1 - 0.2 ms
> SIP OPTIONS request: 7 ms
> SIP REGISTER request: 7 ms
> 
> The measurement was taken between the time a request appeared on 
> ethereal and its response appearing on ethereal. Average was taken 
> manually.
> 
> As you can see, SIP PING requests were sometimes faster to 
> process that 
> STUN requests, but never slower. Actually the SIP PING requests on 
> average were faster to process.
> 
> Myth Busted!!!! :)
> 
> Regards,
> Hisham
> P.S. It took 15 mins to modify the sip stack to do the PING response.
> 
> 

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip